package performancemonster.accumulatedcallgraph;

public interface CallGraphChangeListener
{
  /**
   * A new method has been added. It has been inserted into the node's parent,
   * as the last child.
   */
  public void methodAdded(MethodNode node);
  
  /**
   * A method has been updated.
   */
  public void methodUpdated(MethodNode node);

  /**
   * Two methods are changing place in the parent's list of children.
   * @param goingDown The method going one step down the list.
   * @param goingUp The method going one step up the list.
   */
  public void methodsSwitched(MethodNode goingDown, MethodNode goingUp);
  
  /**
   * An error has occured.
   */
  public void errorAdded(CallGraphError error);
  
  /**
   * The underlying model has been cleared.
   */
  public void elementsCleared();
}
