package performancemonster.accumulatedcallgraph.impl;

import performancemonster.accumulatedcallgraph.CallGraphError;

public class CallGraphErrorImpl implements CallGraphError
{
  private final String category;
  private final String description;
  
  public CallGraphErrorImpl(String category, String description)
  {
    this.category = category;
    this.description = description;
  }

  public CallGraphErrorImpl(
      performancemonster.stretchedcallgraph.CallGraphError error)
  {
    this.category = error.getCategory();
    this.description = error.getDescription();
  }
  
  public String getCategory()
  {
    return category;
  }

  public String getDescription()
  {
    return description;
  }

  @Override
  public int hashCode()
  {
    return getCategory().hashCode() ^ getDescription().hashCode();
  }

  @Override
  public boolean equals(Object other)
  {
    if (!(other instanceof CallGraphErrorImpl)) {
      return false;
    }
    CallGraphErrorImpl otherError = (CallGraphErrorImpl) other;
    return otherError.getCategory().equals(getCategory())
        && otherError.getDescription().equals(getDescription());
  }
  
  @Override
  public String toString()
  {
    return "TreeModelError[" + category + "]: " + description;
  }
}
