package performancemonster.presentation.accumulatedcallgraph.impl;

import java.util.ArrayList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

import performancemonster.accumulatedcallgraph.CallGraphError;

public class ErrorListTableModel extends AbstractTableModel
{
  private final List<CallGraphError> errors;
  
  public ErrorListTableModel()
  {
    errors = new ArrayList<CallGraphError>();
  }
  
  public int getRowCount()
  {
    return errors.size();
  }

  public int getColumnCount()
  {
    return 2;
  }
  
  @Override
  public Class<?> getColumnClass(int columnIndex)
  {
    return String.class;
  }

  public Object getValueAt(int rowIndex, int columnIndex)
  {
    CallGraphError error = errors.get(rowIndex);
    switch (columnIndex) {
    case 0:
      return error.getCategory();
    case 1:
      return error.getDescription();
    default:
      throw new IllegalArgumentException("No column with index " + columnIndex);
    }
  }
  
  public void errorAdded(CallGraphError error)
  {
    int index = errors.size();
    errors.add(error);
    fireTableRowsInserted(index, index);
  }
  
  public void errorsCleared()
  {
    errors.clear();
    fireTableDataChanged();
  }
}
