package performancemonster.presentation.stretchedcallgraph.impl;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import performancemonster.stretchedcallgraph.Analyzer;
import performancemonster.stretchedcallgraph.CallGraphChangeListener;
import performancemonster.stretchedcallgraph.CallGraphError;
import performancemonster.stretchedcallgraph.MethodNode;
import performancemonster.stretchedcallgraph.ThreadNode;

public class ErrorList extends JFrame
{
  public ErrorList(Analyzer analyzer)
  {
    setDefaultCloseOperation(HIDE_ON_CLOSE);
    setLayout(new BorderLayout());
    setTitle("Errors for stretched call graph");

    final ErrorListTableModel tableModel = new ErrorListTableModel();
    analyzer.addChangeListener(new MyCallGraphChangeListener(tableModel));
    JTable list = new JTable(tableModel);
    add(new JScrollPane(list), BorderLayout.CENTER);
  }

  private static final class MyCallGraphChangeListener implements CallGraphChangeListener
  {
    private final ErrorListTableModel model;

    private MyCallGraphChangeListener(ErrorListTableModel model)
    {
      this.model = model;
    }

    public void threadAdded(ThreadNode node)
    {
      // Intentionally left blank
    }

    public void methodAdded(MethodNode node)
    {
      // Intentionally left blank
    }

    public void methodUpdated(MethodNode node)
    {
      // Intentionally left blank
    }

    public void errorAdded(CallGraphError error)
    {
      model.errorAdded(error);
    }

    public void elementsCleared()
    {
      model.errorsCleared();
    }
  }
}
