// PerformanceMonster
// Copyright (C) 2005  Ole Friis <olefriis@gmail.com>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package performancemonster.presentation.stretchedcallgraph.impl;

import java.util.Collection;
import java.util.Comparator;
import java.util.Set;
import java.util.TreeSet;

import javax.swing.tree.TreeNode;

public final class SummaryNode extends Node
{
  public SummaryNode(Collection<performancemonster.stretchedcallgraph.ThreadNode> threadNodes)
  {
    long totalTime = 0;
    Set<performancemonster.stretchedcallgraph.ThreadNode> orderedChildren = new TreeSet<performancemonster.stretchedcallgraph.ThreadNode>(
        new Comparator<performancemonster.stretchedcallgraph.ThreadNode>()
        {
          public int compare(performancemonster.stretchedcallgraph.ThreadNode o1, performancemonster.stretchedcallgraph.ThreadNode o2)
          {
            long timeDiff = o2.getTotalTime() - o1.getTotalTime();
            if (timeDiff > 0) {
              return 1;
            } else if (timeDiff < 0) {
              return -1;
            }
            return o1.getName().compareTo(o2.getName());
          }
        });
    orderedChildren.addAll(threadNodes);
    for (performancemonster.stretchedcallgraph.ThreadNode m : orderedChildren) {
      children
          .add(new ThreadNode(
              this, m));
      totalTime += m.getTotalTime();
    }
  }

  @Override
  public TreeNode getParent()
  {
    return null;
  }

  @Override
  public String toString()
  {
    return "Summary";
  }

  @Override
  public String getTotalTime()
  {
    return "";
  }

  @Override
  public String getTimeInMethod()
  {
    return "";
  }

  @Override
  public String getName()
  {
    return "Summary";
  }
  
  @Override
  public long getId()
  {
    throw new UnsupportedOperationException(
        "getId is not applicable to SummaryNode");
  }
  
  public void clearChildren()
  {
    children.clear();
  }
  
  public void addChild(ThreadNode node)
  {
    children.add(node);
  }
}
