// PerformanceMonster
// Copyright (C) 2005  Ole Friis <olefriis@gmail.com>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package performancemonster.presentation.stretchedcallgraph.impl;

import javax.swing.tree.TreeNode;

public final class ThreadNode extends Node
{
  private final performancemonster.stretchedcallgraph.ThreadNode threadNode;
  private final Node parent;

  public ThreadNode(Node parent,
      performancemonster.stretchedcallgraph.ThreadNode threadNode)
  {
    this.threadNode = threadNode;
    this.parent = parent;
    for (performancemonster.stretchedcallgraph.MethodNode m : threadNode.getChildren()) {
      children
          .add(new performancemonster.presentation.stretchedcallgraph.impl.MethodNode(
              this, m));
    }
  }

  @Override
  public TreeNode getParent()
  {
    return parent;
  }

  @Override
  public String toString()
  {
    return "Thread " + threadNode.getThreadId();
  }

  @Override
  public String getTotalTime()
  {
    return "";
  }

  @Override
  public String getTimeInMethod()
  {
    return "";
  }

  @Override
  public String getName()
  {
    return threadNode.getName();
  }
  
  @Override
  public long getId()
  {
    return threadNode.getThreadId();
  }
}
