package performancemonster.stretchedcallgraph;

import performancemonster.graph.GraphElement;

public interface Node
{
  public Node getParent();
  public Node addChild(GraphElement element);
  
  /**
   * Gives the name of this node.
   * 
   * @return The name of this node.
   */
  public String getName();
  
  /**
   * Gives the total time spent in this method.
   * 
   * @return
   * @throws IllegalStateException
   *           if
   * @link #isEnded() is <code>false</code>
   */
  public long getTotalTime();

  /**
   * Gives the time spent in this method, excluding the time spent in
   * sub-methods.
   * 
   * @return
   * @throws IllegalStateException
   *           if
   * @link #isEnded() is <code>false</code>
   */
  public long getTimeInMethod();
  
  /**
   * Indicates whether or not the underlying graph element is ended or not.
   * 
   * @return <code>true</code> if the underlying graph element is ended,
   *         <code>false</code> otherwise.
   */
  public boolean isEnded();
}
