/**
 * 
 */
package performancemonster.test.accumulatedcallgraph;

import java.util.HashSet;
import java.util.Set;

import org.easymock.IArgumentMatcher;

import performancemonster.accumulatedcallgraph.MethodNode;

public class MethodNodeEquals implements IArgumentMatcher
{
  private final Set<Long> expectedIds;

  public MethodNodeEquals(long... expectedIds)
  {
    this.expectedIds = new HashSet<Long>();
    for (long l : expectedIds) {
      this.expectedIds.add(l);
    }
  }

  public boolean matches(Object actual)
  {
    if (!(actual instanceof MethodNode)) {
      return false;
    }
    MethodNode methodNode = (MethodNode) actual;
    return methodNode.getElementIds().equals(expectedIds);
  }

  public void appendTo(StringBuffer buffer)
  {
    buffer.append("MethodNodeEquals(");
    buffer.append(expectedIds);
    buffer.append(")");
  }
}